package lab2;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JDesktopPane;
import java.awt.Rectangle;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JTextPane;
import javax.swing.JScrollPane;

public class LanzadorFrame extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JDesktopPane jDesktopPane = null;

	private JLabel jLabelNombre = null;

	private JTextField jTextFieldEjecutarNombre = null;

	private JButton jButtonEjecutar = null;

	private JButton jButtonAsignar = null;

	private JTextPane jTextPaneMensajes = null;

	private JScrollPane jScrollPaneMensajes = null;

	/**
	 * This is the default constructor
	 */
	public LanzadorFrame() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(397, 396);
		this.setContentPane(getJContentPane());
		this.setTitle("Para lanzar Presentacion y asignar Logica de Negocio");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJDesktopPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jDesktopPane	
	 * 	
	 * @return javax.swing.JDesktopPane	
	 */
	private JDesktopPane getJDesktopPane() {
		if (jDesktopPane == null) {
			jLabelNombre = new JLabel();
			jLabelNombre.setBounds(new Rectangle(15, 15, 361, 31));
			jLabelNombre.setText("Nombre de la clase con la lgica del negocio");
			jDesktopPane = new JDesktopPane();
			jDesktopPane.add(jLabelNombre, null);
			jDesktopPane.add(getJTextFieldEjecutarNombre(), null);
			jDesktopPane.add(getJButtonEjecutar(), null);
			jDesktopPane.add(getJButtonAsignar(), null);
			jDesktopPane.add(getJScrollPaneMensajes(), null);
		}
		return jDesktopPane;
	}

	/**
	 * This method initializes jTextFieldEjecutarNombre	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldEjecutarNombre() {
		if (jTextFieldEjecutarNombre == null) {
			jTextFieldEjecutarNombre = new JTextField();
			jTextFieldEjecutarNombre.setBounds(new Rectangle(15, 60, 361, 31));
		}
		return jTextFieldEjecutarNombre;
	}

	/**
	 * This method initializes jButtonEjecutar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonEjecutar() {
		if (jButtonEjecutar == null) {
			jButtonEjecutar = new JButton();
			jButtonEjecutar.setBounds(new Rectangle(74, 105, 242, 32));
			jButtonEjecutar.setText("Ejecutar Presentacion");
			jButtonEjecutar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (Lanzador.pre == null) {
						Lanzador.pre = new Presentacion();
						Lanzador.pre.setVisible(true);
					}
				}
			});
		}
		return jButtonEjecutar;
	}

	/**
	 * This method initializes jButtonAsignar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonAsignar() {
		if (jButtonAsignar == null) {
			jButtonAsignar = new JButton();
			jButtonAsignar.setBounds(new Rectangle(75, 150, 241, 31));
			jButtonAsignar.setText("Asignar Logica de Negocio");
			jButtonAsignar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{
						InterfaceLogicaNegocio intLN = (InterfaceLogicaNegocio)Class.forName(jTextFieldEjecutarNombre.getText()).newInstance();
						// para crear una instancia de la clase cuyo nombre est en jTextFieldEjecutarNombre
						Lanzador.pre.setLogicaNegocio(intLN);
						jTextPaneMensajes.setText(jTextPaneMensajes.getText() + "\n" + "Logica de negocio: " + jTextFieldEjecutarNombre.getText());
					} catch (ClassNotFoundException ex) {
						jTextPaneMensajes.setText(jTextPaneMensajes.getText() + "\n" + "Clase no encontrada: " + jTextFieldEjecutarNombre.getText());
					} catch (IllegalAccessException ex) {
						jTextPaneMensajes.setText(jTextPaneMensajes.getText() + "\n" + "Acceso ilegal: " + jTextFieldEjecutarNombre.getText());
					} catch (java.lang.NullPointerException ex) {
						jTextPaneMensajes.setText(jTextPaneMensajes.getText() + "\n" + "La clase Presentacion no est en ejecucin");
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
			});
		};
		return jButtonAsignar;
	}

	/**
	 * This method initializes jTextPaneMensajes	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getJTextPaneMensajes() {
		if (jTextPaneMensajes == null) {
			jTextPaneMensajes = new JTextPane();
			jTextPaneMensajes.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		}
		return jTextPaneMensajes;
	}

	/**
	 * This method initializes jScrollPaneMensajes	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneMensajes() {
		if (jScrollPaneMensajes == null) {
			jScrollPaneMensajes = new JScrollPane();
			jScrollPaneMensajes.setBounds(new Rectangle(15, 195, 361, 151));
			jScrollPaneMensajes.setViewportView(getJTextPaneMensajes());
		}
		return jScrollPaneMensajes;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
